//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%43A85FFA0247.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%43A85FFA0247.cm

//## begin module%43A85FFA0247.cp preserve=no
//## end module%43A85FFA0247.cp

//## Module: UniqueEnergy%43A85FFA0247; Package specification
//## Subsystem: XSModel::Model%368927CA4068
//	/local/data/verisB/dorman/Xspec/src/model
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/UniqueEnergy.h

#ifndef UNIQUEENERGY_H
#define UNIQUEENERGY_H 1

//## begin module%43A85FFA0247.additionalIncludes preserve=no
//## end module%43A85FFA0247.additionalIncludes

//## begin module%43A85FFA0247.includes preserve=yes
//## end module%43A85FFA0247.includes

//## begin module%43A85FFA0247.declarations preserve=no
//## end module%43A85FFA0247.declarations

//## begin module%43A85FFA0247.additionalDeclarations preserve=yes
#include <xsTypes.h>
#include <set>

//## end module%43A85FFA0247.additionalDeclarations


//## begin UniqueEnergy%43A861BA02A8.preface preserve=yes
//## end UniqueEnergy%43A861BA02A8.preface

//## Class: UniqueEnergy%43A861BA02A8
//## Category: XSModel::Model%36349D1B0171
//## Subsystem: XSModel::Model%368927CA4068
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class UniqueEnergy 
{
  //## begin UniqueEnergy%43A861BA02A8.initialDeclarations preserve=yes
  //## end UniqueEnergy%43A861BA02A8.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: UniqueEnergy%43A864080195
      UniqueEnergy (const RealArray& energies);

    //## Destructor (generated)
      ~UniqueEnergy();


    //## Other Operations (specified)
      //## Operation: addClient%43A867DC0378
      void addClient (size_t specNum);

      //## Operation: removeClient%43A867EF0252
      bool removeClient (size_t specNum);

      //## Operation: removeAllClients%44035C36016F
      void removeAllClients ();

      //## Operation: changeEnergy%44119C2E01ED
      void changeEnergy (const RealArray& newEnergy);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: energy%43A8661100B6
      const RealArray& energy () const;

      //## Attribute: clientSpectra%43A8668E007F
      const std::set<size_t>& clientSpectra () const;

      //## Attribute: associatedGain%43C3E2A00083
      const std::vector<Real>& associatedGain () const;
      void associatedGain (const std::vector<Real>& value);

      //## Attribute: dontShare%4411B78900BB
      bool dontShare () const;
      void dontShare (bool value);

    // Additional Public Declarations
      //## begin UniqueEnergy%43A861BA02A8.public preserve=yes
      //## end UniqueEnergy%43A861BA02A8.public

  protected:
    // Additional Protected Declarations
      //## begin UniqueEnergy%43A861BA02A8.protected preserve=yes
      //## end UniqueEnergy%43A861BA02A8.protected

  private:
    //## Assignment Operation (generated)
      UniqueEnergy & operator=(const UniqueEnergy &right);

    // Additional Private Declarations
      //## begin UniqueEnergy%43A861BA02A8.private preserve=yes
      //## end UniqueEnergy%43A861BA02A8.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin UniqueEnergy::energy%43A8661100B6.attr preserve=no  public: RealArray {U} 
      RealArray m_energy;
      //## end UniqueEnergy::energy%43A8661100B6.attr

      //## begin UniqueEnergy::clientSpectra%43A8668E007F.attr preserve=no  public: std::set<size_t> {U} 
      std::set<size_t> m_clientSpectra;
      //## end UniqueEnergy::clientSpectra%43A8668E007F.attr

      //## begin UniqueEnergy::associatedGain%43C3E2A00083.attr preserve=no  public: std::vector<Real> {U} 
      std::vector<Real> m_associatedGain;
      //## end UniqueEnergy::associatedGain%43C3E2A00083.attr

      //## begin UniqueEnergy::dontShare%4411B78900BB.attr preserve=no  public: bool {U} 
      bool m_dontShare;
      //## end UniqueEnergy::dontShare%4411B78900BB.attr

    // Additional Implementation Declarations
      //## begin UniqueEnergy%43A861BA02A8.implementation preserve=yes
      //## end UniqueEnergy%43A861BA02A8.implementation

};

//## begin UniqueEnergy%43A861BA02A8.postscript preserve=yes
//## end UniqueEnergy%43A861BA02A8.postscript

// Class UniqueEnergy 


//## Other Operations (inline)
inline void UniqueEnergy::removeAllClients ()
{
  //## begin UniqueEnergy::removeAllClients%44035C36016F.body preserve=yes
  m_clientSpectra.clear();
  //## end UniqueEnergy::removeAllClients%44035C36016F.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const RealArray& UniqueEnergy::energy () const
{
  //## begin UniqueEnergy::energy%43A8661100B6.get preserve=no
  return m_energy;
  //## end UniqueEnergy::energy%43A8661100B6.get
}

inline const std::set<size_t>& UniqueEnergy::clientSpectra () const
{
  //## begin UniqueEnergy::clientSpectra%43A8668E007F.get preserve=no
  return m_clientSpectra;
  //## end UniqueEnergy::clientSpectra%43A8668E007F.get
}

inline const std::vector<Real>& UniqueEnergy::associatedGain () const
{
  //## begin UniqueEnergy::associatedGain%43C3E2A00083.get preserve=no
  return m_associatedGain;
  //## end UniqueEnergy::associatedGain%43C3E2A00083.get
}

inline void UniqueEnergy::associatedGain (const std::vector<Real>& value)
{
  //## begin UniqueEnergy::associatedGain%43C3E2A00083.set preserve=no
  m_associatedGain = value;
  //## end UniqueEnergy::associatedGain%43C3E2A00083.set
}

inline bool UniqueEnergy::dontShare () const
{
  //## begin UniqueEnergy::dontShare%4411B78900BB.get preserve=no
  return m_dontShare;
  //## end UniqueEnergy::dontShare%4411B78900BB.get
}

inline void UniqueEnergy::dontShare (bool value)
{
  //## begin UniqueEnergy::dontShare%4411B78900BB.set preserve=no
  m_dontShare = value;
  //## end UniqueEnergy::dontShare%4411B78900BB.set
}

//## begin module%43A85FFA0247.epilog preserve=yes
//## end module%43A85FFA0247.epilog


#endif
